# Vortragsnotizen

Dinge, die mir so auffallen und erwähnt werden sollten.

## `gobind` Besonderheiten

All das hier gilt für die via `gobind` generierten Interfaces.  
Was unter der Haube passiert ist davon unbeeinträchtigt.


### Keine Pointer Parameter in `gobind`

Nervig, da Strukturen im Allgemeinen by-value übergeben werden.
Ändere ich also einen Wert juckt es keinen. Es passiert nur für mich.


### `[]byte` Rückgabewert ist veränderlich

Anpassungen an dem Rückgabewert können das zu Grunde liegende Array verändern.
Wurde es also nicht nur für den Zweck der Rückgabe zusammengezimmert sondern als interne Daten rausgegeben, können Instabilitäten im Programm von Außen reingeworfen werden.
Muss nicht, es gibt Situationen in denen das zu Grunde liegende Array als eine Kopie erzeugt wird. In den meisten Fällen jedoch ist das Array veränderbar.


## Generell

Das ist mir als ausgesprochen nervig aufgefallen und ich habe nicht genug Erfahrung damit, um eine Lösung hierzu präsentieren zu können.


### `gps.Coordinates`: Setzen von Boundaries vs. JSON Encoding
```
type Coordinate struct {
  latitude  float64 `json:"lat"`
  longitude float64 `json:"lon"`
}

func CoordinateWithLatitudeAndLongitude(float64, float64) Coordinate
func (c *Coordinate) SetLatitude(float64)
func (c Coordinate)  Latitude() float64
func (c *Coordinate) SetLongitude(float64)
func (c Coordinate)  Longitude() float64 
```

Das Paket `encoding/json` kann hier nichts tun.
Da die Felder `latitude` und `longitude` nicht exportiert sind, kann es trotz Annotation nicht darauf zugreifen.
Die Setter-Methoden werden ebenfalls nicht angesprungen.
Ändere ich den Scope, sind nicht nur die Getter redundant, spätestens `gobind` meckert doppelte Setter an, da diese bei exportierten Feldern automatisch generiert werden.

Schlimmer ist aber, dass ich mir die Möglichkeit der Steuerung von Eingaben durch diesen Export zerstöre.
Hier ließe sich vielleicht mit exportierten RawValues und privaten Checked-Flags behelfen...

```
type Coordinate struct {
  RawLat    float64 `json:"lat"`
  RawLon    float64 `json:"lon"`
  latitude  float64
  longitude float64
  chkdLat   bool
  chkdLon   bool
}

func CoordinateWithLatitudeAndLongitude(float64, float64) Coordinate
func (c *Coordinate) SetLatitude(float64)
func (c Coordinate)  Latitude() (float64, error)
func (c *Coordinate) SetLongitude(float64)
func (c Coordinate)  Longitude() (float64, error)
func (c Coordinate)  SanityCheck() (bool, error) 
func (c *Coordinate) Sanitize() error
```
