package gps_test

import (
	"mfs.de/gps"
	"testing"
)

func TestCoordinate_CreationValidValues(t *testing.T) {
	latitude := 10.93
	longitude := 9.85
	coordinateInTesting := gps.CoordinatesWithLatLong(latitude, longitude)
	if coordinateInTesting.Latitude() != latitude {
		t.Errorf("Setting latitude from function failed. Wanted %#v, got %#v", latitude, coordinateInTesting.Latitude())
	}
	if coordinateInTesting.Longitude() != longitude {
		t.Errorf("Setting longitude from function failed. Wanted %#v, got %#v", longitude, coordinateInTesting.Longitude())
	}
}

func TestCoordinates_CreationLowerBoundLatitude(t *testing.T) {
	allowedBoundaryValue := -90.0
	latitude := -255.0
	longitude := 9.85
	coordinateInTesting := gps.CoordinatesWithLatLong(latitude, longitude)
	if coordinateInTesting.Latitude() != allowedBoundaryValue {
		t.Errorf("Setting latitude from function failed. Wanted %#v, got %#v", allowedBoundaryValue, coordinateInTesting.Latitude())
	}
	if coordinateInTesting.Longitude() != longitude {
		t.Errorf("Setting longitude from function failed. Wanted %#v, got %#v", longitude, coordinateInTesting.Longitude())
	}
}

func TestCoordinates_CreationUpperBoundLatitude(t *testing.T) {
	allowedBoundaryValue := 90.0
	latitude := 255.0
	longitude := 9.85
	coordinateInTesting := gps.CoordinatesWithLatLong(latitude, longitude)
	if coordinateInTesting.Latitude() != allowedBoundaryValue {
		t.Errorf("Setting latitude from function failed. Wanted %#v, got %#v", allowedBoundaryValue, coordinateInTesting.Latitude())
	}
	if coordinateInTesting.Longitude() != longitude {
		t.Errorf("Setting longitude from function failed. Wanted %#v, got %#v", longitude, coordinateInTesting.Longitude())
	}
}

func TestCoordinates_CreationLowerBoundLongitude(t *testing.T) {
	allowedBoundaryValue := -180.0
	latitude := 10.93
	longitude := -255.0
	coordinateInTesting := gps.CoordinatesWithLatLong(latitude, longitude)
	if coordinateInTesting.Latitude() != latitude {
		t.Errorf("Setting latitude from function failed. Wanted %#v, got %#v", latitude, coordinateInTesting.Latitude())
	}
	if coordinateInTesting.Longitude() != allowedBoundaryValue {
		t.Errorf("Setting longitude from function failed. Wanted %#v, got %#v", allowedBoundaryValue, coordinateInTesting.Longitude())
	}
}

func TestCoordinates_CreationUpperBoundLongitude(t *testing.T) {
	allowedBoundaryValue := 180.0
	latitude := 10.93
	longitude := 255.0
	coordinateInTesting := gps.CoordinatesWithLatLong(latitude, longitude)
	if coordinateInTesting.Latitude() != latitude {
		t.Errorf("Setting latitude from function failed. Wanted %#v, got %#v", latitude, coordinateInTesting.Latitude())
	}
	if coordinateInTesting.Longitude() != allowedBoundaryValue {
		t.Errorf("Setting longitude from function failed. Wanted %#v, got %#v", allowedBoundaryValue, coordinateInTesting.Longitude())
	}
}
